var thfaqf_public = (function($, window, document) {
    'use strict';

    function initialize_thfaqf(){
        setup_faq_accordion();
        setup_share_icons();
    }

    function setup_faq_accordion(){
        var open_multiple = thfaqf_public_var.open_multiple_faqs;
        var faq_wrapper = $('.thfaqf-faq-list');

        open_first_faq_tab(faq_wrapper);

        $('.thfaqf-faq-item-title').click(function(){
            if(open_multiple != 'yes'){
                var wrapper = $(this).closest('.thfaqf-faq-list');
                close_all_other_faq_tabs($(this), wrapper);
            }
            toggle_faq_tab($(this));
        });
    }

    function close_all_other_faq_tabs(elm, wrapper){
        var faq_item = elm.closest('.thfaqf-faq-item');
        var other_faq_items = faq_item.siblings('.thfaqf-faq-item');

        // other_faq_items.find('.thfaqf-faq-item-content').hide();
        other_faq_items.find('.thfaqf-faq-item-content').slideUp('fast');
        other_faq_items.removeClass("thfaqf-active");
    }

    function toggle_faq_tab(elm){
        elm.next().slideToggle('fast'); 
        elm.closest('.thfaqf-faq-item').toggleClass("thfaqf-active");
    }

    function open_faq_tab(elm){
        elm.find('.thfaqf-faq-item-content').slideDown();
        if(!elm.hasClass("thfaqf-active")){
            elm.addClass("thfaqf-active");
        }
    }

    function open_first_faq_tab(wrapper){
        wrapper.each(function() {
            var active_item = $(this).find('.thfaqf-faq-item.thfaqf-active');
            open_faq_tab(active_item);
        });
    }

    function setup_share_icons(){
        $('a.thfaqf-share-icon').click(function(e){
            e.preventDefault(); 
            var url = $(this).attr('data-url'); 
            window.open(url, 'newwindow','width=600, height=400');
        });
    }

    /***----- INIT -----***/
    initialize_thfaqf();

}(window.jQuery, window, document));

