<?php
if(!defined('WPINC')){	die; }

if(!class_exists('THFAQF_Public')):

class THFAQF_Public {
    public function __construct(){
    	add_shortcode("FAQ", array($this, 'faq_shortcode'));
    }   

    public function enqueue_styles_and_scripts(){
		wp_register_style('thfaqf-public-style', THFAQF_ASSETS_URL_PUBLIC.'css/thfaqf-public.css');
	    wp_register_style('styleicon', THFAQF_ASSETS_URL_PUBLIC.'css/social-share-kit.css');

	    wp_enqueue_style('thfaqf-public-style');
	    wp_enqueue_style('styleicon' );

	    wp_register_script('thfaqf-public-script', THFAQF_ASSETS_URL_PUBLIC.'js/thfaqf-public.js', array('jquery'), THFAQF_VERSION, true);
    	wp_register_script('shareme', THFAQF_ASSETS_URL_PUBLIC.'js/sharer.min.js', array('jquery'), THFAQF_VERSION, true);

		wp_enqueue_script('thfaqf-public-script');
		wp_enqueue_script('shareme');

		$open_multiple_faqs = THFAQF_Utils::get_settings('open_multiple_faqs');
		$faqf_var = array(
			'open_multiple_faqs' => ($open_multiple_faqs || $open_multiple_faqs === 'yes') ? 'yes' : 'no',
		);
		wp_localize_script('thfaqf-public-script', 'thfaqf_public_var', $faqf_var);
	}

	public function display_shortcode_content($content){
	    if(is_single()){
	        $faq_post_id = get_the_ID();
            $post_type = get_post_type($faq_post_id);
            
            if($post_type == 'faq'){
		        $this->faq_list($faq_post_id);
		    }
	    }
	   return $content;
	}	

	public function faq_shortcode($atts){    
        $args = shortcode_atts( array(
            'id' => '',
        ), $atts );

        $invalid_ids = array();
        $faq_post_ids = explode(',', $args['id']);

        ob_start();
        foreach($faq_post_ids as $faq_post_id){
            $post_status = get_post_status($faq_post_id);
            $post_type = get_post_type($faq_post_id);

            if($post_type == 'faq' && $post_status == 'publish'){
                $this->faq_list($faq_post_id);
            }else{
                array_push($invalid_ids, $faq_post_id);
            }
        }

        $invalid_ids = implode(',', $invalid_ids);
        echo $invalid_faq_html = !empty($invalid_ids) ? '[FAQ id="'.$invalid_ids.'"]' : '';
        return ob_get_clean();
    }

	public function faq_list($post_id){
		$faqs = get_post_meta($post_id, THFAQF_Utils::OPTION_KEY_FAQ_ITEMS, true);
		if(empty($faqs)){
			return;
		}

		$global_settings = THFAQF_Utils::get_faq_settings();
		$local_settings = get_post_meta($post_id, THFAQF_Utils::OPTION_KEY_FAQ_SETTINGS_POST, true);
		$settings = $this->prepare_faq_settings($global_settings, $local_settings);

		$border_radius = isset($settings['faq_border_radius']) ? $settings['faq_border_radius'] : 0;
		$border_radius = is_numeric($border_radius) ? $border_radius : 0;
		$title_color = isset($settings['title_color']) ? $settings['title_color'] : false;
		$title_bg = isset($settings['title_bg_color']) ? $settings['title_bg_color'] : false;
		$content_color = isset($settings['content_color']) ? $settings['content_color'] : false;
		$content_bg = isset($settings['content_bg_color']) ? $settings['content_bg_color'] : false;

		$show_updated_date = THFAQF_Utils::get_setting_value($settings, 'show_updated_date');

		$accordion_display_mode = THFAQF_Utils::get_setting_value($settings, 'accordion_display_mode');
		$accordion_display_mode = $accordion_display_mode ? $accordion_display_mode : 'open_first';
		$fist_item_active_class = $accordion_display_mode === 'open_first' ? ' thfaqf-active' : '';

		$theme_wrapper_class = $this->get_theme_wrapper_class();
		$item_wrapper_style  = '';
		$item_title_style    = 'border-width: 1px; border-style: solid; margin-bottom: -1px;';
		$item_content_style  = 'border-width: 1px; border-style: solid;';
		$title_text_style    = '';
		
		if($border_radius){
			$item_wrapper_style .= 'border-radius: '.$border_radius.'px;';
		}

		if($title_bg){
			$item_title_style .= ' background-color: '.$title_bg.'; border-color: '.$title_bg.';';
		}
		if($title_color){
			$title_text_style .= ' color: '.$title_color.';';
		}

		if($content_bg){
			$item_content_style .= ' background-color: '.$content_bg.'; border-color: '.$content_bg.';';
		}
		if($content_color){
			$item_content_style .= ' color: '.$content_color.';';
		}

		?>
		<div class="thfaqf-faq-list <?php echo $theme_wrapper_class ?>">
	        <h3 class="thfaqf-faq-list-title"><?php echo get_the_title($post_id); ?></h3>
	        <?php

	        if($show_updated_date === "yes" || $show_updated_date == 1){ 
	        	$last_updated = get_the_modified_date(get_option('date_format'), $post_id);
	        	echo '<p class="thfaqf-faq-last-updated">'. $last_updated .'</p>';
			}

			$index = 0;
	        foreach($faqs as $key => $faq_item){
	        	$item_wrapper_class = $index === 0 ? $fist_item_active_class : '';

	        	$this->display_faq_item($faq_item, $item_wrapper_class, $item_wrapper_style, $item_title_style, $item_content_style, $title_text_style);
	        	$index++;
	        }

	        $this->display_social_share($post_id, $settings);
	        $this->display_edit_link($post_id);
	        ?>
	    </div>
	    <?php 
	}

	public function display_faq_item($faq_item, $item_wrapper_class, $item_wrapper_style, $item_title_style, $item_content_style, $title_text_style){
		$faq_title = isset($faq_item['faq_title']) ? $faq_item['faq_title'] : '';
		$faq_title = htmlspecialchars_decode($faq_title);

		$faq_content = isset($faq_item['faq_content']) ? $faq_item['faq_content'] : '';
		$faq_content = htmlspecialchars_decode($faq_content);
		?>
		<div class="thfaqf-faq-item <?php echo $item_wrapper_class; ?>" style="<?php echo $item_wrapper_style; ?>" >
			<div class="thfaqf-faq-item-title" style="<?php echo $item_title_style; ?>" >
 				<h4><span class="thfaqf-title-text" style="<?php echo $title_text_style; ?>" ><?php echo esc_html($faq_title);?></span><span class="thfaqf-toggle-icon"></span></h4>
			</div>
			<div class="thfaqf-faq-item-content" style="<?php echo $item_content_style; ?>" >
				<?php echo wpautop($faq_content);?>
			</div>
			<div class="log"></div>
		</div>
 		<?php 
	}

	public function display_social_share($post_id, $settings){
		$enabled_share_button = THFAQF_Utils::get_setting_value($settings, 'enable_share_button');

		if($enabled_share_button === 'yes' || $enabled_share_button == 1){
			$post_url = get_post_permalink($post_id);
	   		$social_share_icons = THFAQF_Utils::get_setting_value($settings, 'social_share_options');
	   		$social_share_icons = $social_share_icons ? explode(',', $social_share_icons) : false;

	   		$social_share_html = '';
	   		if(is_array($social_share_icons)){
	   			foreach($social_share_icons as $key){
	   				$link = '';

	   				if($key === 'twitter'){
	   					$url  = 'https://twitter.com/home?status='.$post_url;
						$link = '<a title="Twitter" class="thfaqf-share-icon thfaqf-icon-twitter" data-url="'.$url.'"></a>';

	   				}else if($key === 'facebook'){
	   					$url  = 'https://facebook.com/home?status='.$post_url;
						$link = '<a title="Facebook" class="thfaqf-share-icon thfaqf-icon-facebook" data-url="'.$url.'"></a>';

	   				}else if($key === 'email'){
	   					$url  = 'mailto:info@example.com?&subject=&body='.$post_url;
						$link = '<a title="Email" class="thfaqf-share-icon thfaqf-icon-email" data-url="'.$url.'"></a>';

	   				}else if($key === 'linkedin'){
	   					$url  = 'https://www.linkedin.com/shareArticle?mini=true&url='.$post_url;
						$link = '<a title="Linkedin" class="thfaqf-share-icon thfaqf-icon-linkedin" data-url="'.$url.'"></a>';
	   				}

	   				$social_share_html .= $link;
	   			}
	   		}

	   		if($social_share_html){
	   			$social_share_title = THFAQF_Utils::get_setting_value($settings, 'social_share_title');
	   			$social_share_title_class = 'thfaqf-social-share-title';
	   			$social_share_title_tooltip = '';

	   			if(strlen($social_share_title) > 25){
	   				$social_share_title_class .= ' width-200';
	   				$social_share_title_tooltip = $social_share_title;
	   			}
	   			
	   			?>
	   			<p class='thfaqf-social-share-wrapper'>
	   				<span class='<?php echo $social_share_title_class; ?>' title='<?php echo $social_share_title_tooltip; ?>'>
	   					<?php echo $social_share_title; ?>
	   				</span>
	   				<?php echo $social_share_html; ?>
	   			</p>
	   			<?php
	   		}
		}
	}

	public function display_edit_link($post_id){
	    if((current_user_can('administrator') and !is_singular('faq')) or (current_user_can('manage_woocommerce') and !is_singular('faq'))) {
	    	$edit_url = get_edit_post_link($post_id);
	    	?>
	    	<p class="thfaqf-edit-faq-link"><a href="<?php echo $edit_url; ?>" >Edit FAQ</a></p>
	    	<?php	 
	    }
	}

	private function prepare_faq_settings($global_settings, $local_settings){
		if(is_array($local_settings)){
			$override_settings = isset($local_settings['override_global_settings']) ? $local_settings['override_global_settings']: false;
			
			if($override_settings === 'yes' || $override_settings == 1){
				foreach($local_settings as $key => $value) {
					if($value){
						$global_settings[$key] = $value;
					}
				}
			}
		}
		return $global_settings;
	}
    
    public function get_theme_wrapper_class(){
    	$current_theme = wp_get_theme();
    	$current_theme_name = isset($current_theme['Template']) ? $current_theme['Template'] : '';

    	$wrapper_class = '';
    	if($current_theme_name){
    		$wrapper_class = str_replace(' ', '-', strtolower($current_theme_name));
    		$wrapper_class = 'thfaqf-theme-wrapper-'.$wrapper_class;
    	}
       	return $wrapper_class;
    }

	public function prepare_colour_settings($faq_cleaned_color, $general_settings){
        $settings_fields = THFAQF_Utils::get_settings_fields();

		$use_post_settings =  isset($faq_cleaned_color['use_post_settings']) ? $faq_cleaned_color['use_post_settings'] : '';
		if(($use_post_settings == 'yes') and (!empty($faq_cleaned_color))){
            $title_color       = isset($faq_cleaned_color['title_color'])?$faq_cleaned_color['title_color']:'';
			$title_bg_color    = isset($faq_cleaned_color['title_bg_color'])?$faq_cleaned_color['title_bg_color']:'';
			$content_color     = isset($faq_cleaned_color['content_color'])?$faq_cleaned_color['content_color']:'';
			$content_bg_color  = isset($faq_cleaned_color['content_bg_color'])?$faq_cleaned_color['content_bg_color']:'';
		}else{
			$title_color       = isset($general_settings['title_color'])?$general_settings['title_color']:$settings_fields['title_color']['value'];
			$title_bg_color    = isset($general_settings['title_bg_color'])?$general_settings['title_bg_color']:$settings_fields['title_bg_color']['value'];
			$content_color     = isset($general_settings['content_color'])?$general_settings['content_color']:$settings_fields['content_color']['value'];
			$content_bg_color  = isset($general_settings['content_bg_color'])?$general_settings['content_bg_color']:$settings_fields['content_bg_color']['value'];   
		}
		$data = array(
			'title_color'      => $title_color,
			'title_bg_color'   => $title_bg_color,
			'content_color'    => $content_color,
			'content_bg_color' => $content_bg_color,
		);
		return $data;
	}
}//end class

endif;
